<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/aho-corasick-0.7.18/src/packed/pattern.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>pattern.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../aho_corasick/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../aho_corasick/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../aho_corasick/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::cmp</span>;
<span class="kw">use</span> <span class="ident">std::fmt</span>;
<span class="kw">use</span> <span class="ident">std::mem</span>;
<span class="kw">use</span> <span class="ident">std::u16</span>;
<span class="kw">use</span> <span class="ident">std::usize</span>;

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::packed::api::MatchKind</span>;

<span class="doccomment">/// The type used for representing a pattern identifier.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// We don&#39;t use `usize` here because our packed searchers don&#39;t scale to</span>
<span class="doccomment">/// huge numbers of patterns, so we keep things a bit smaller.</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">PatternID</span> <span class="op">=</span> <span class="ident">u16</span>;

<span class="doccomment">/// A non-empty collection of non-empty patterns to search for.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This collection of patterns is what is passed around to both execute</span>
<span class="doccomment">/// searches and to construct the searchers themselves. Namely, this permits</span>
<span class="doccomment">/// searches to avoid copying all of the patterns, and allows us to keep only</span>
<span class="doccomment">/// one copy throughout all packed searchers.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Note that this collection is not a set. The same pattern can appear more</span>
<span class="doccomment">/// than once.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Patterns</span> {
    <span class="doccomment">/// The match semantics supported by this collection of patterns.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The match semantics determines the order of the iterator over patterns.</span>
    <span class="doccomment">/// For leftmost-first, patterns are provided in the same order as were</span>
    <span class="doccomment">/// provided by the caller. For leftmost-longest, patterns are provided in</span>
    <span class="doccomment">/// descending order of length, with ties broken by the order in which they</span>
    <span class="doccomment">/// were provided by the caller.</span>
    <span class="ident">kind</span>: <span class="ident">MatchKind</span>,
    <span class="doccomment">/// The collection of patterns, indexed by their identifier.</span>
    <span class="ident">by_id</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    <span class="doccomment">/// The order of patterns defined for iteration, given by pattern</span>
    <span class="doccomment">/// identifiers. The order of `by_id` and `order` is always the same for</span>
    <span class="doccomment">/// leftmost-first semantics, but may be different for leftmost-longest</span>
    <span class="doccomment">/// semantics.</span>
    <span class="ident">order</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">PatternID</span><span class="op">&gt;</span>,
    <span class="doccomment">/// The length of the smallest pattern, in bytes.</span>
    <span class="ident">minimum_len</span>: <span class="ident">usize</span>,
    <span class="doccomment">/// The largest pattern identifier. This should always be equivalent to</span>
    <span class="doccomment">/// the number of patterns minus one in this collection.</span>
    <span class="ident">max_pattern_id</span>: <span class="ident">PatternID</span>,
    <span class="doccomment">/// The total number of pattern bytes across the entire collection. This</span>
    <span class="doccomment">/// is used for reporting total heap usage in constant time.</span>
    <span class="ident">total_pattern_bytes</span>: <span class="ident">usize</span>,
}

<span class="kw">impl</span> <span class="ident">Patterns</span> {
    <span class="doccomment">/// Create a new collection of patterns for the given match semantics. The</span>
    <span class="doccomment">/// ID of each pattern is the index of the pattern at which it occurs in</span>
    <span class="doccomment">/// the `by_id` slice.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If any of the patterns in the slice given are empty, then this panics.</span>
    <span class="doccomment">/// Similarly, if the number of patterns given is zero, then this also</span>
    <span class="doccomment">/// panics.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="ident">Patterns</span> {
        <span class="ident">Patterns</span> {
            <span class="ident">kind</span>: <span class="ident">MatchKind::default</span>(),
            <span class="ident">by_id</span>: <span class="macro">vec!</span>[],
            <span class="ident">order</span>: <span class="macro">vec!</span>[],
            <span class="ident">minimum_len</span>: <span class="ident">usize::MAX</span>,
            <span class="ident">max_pattern_id</span>: <span class="number">0</span>,
            <span class="ident">total_pattern_bytes</span>: <span class="number">0</span>,
        }
    }

    <span class="doccomment">/// Add a pattern to this collection.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This panics if the pattern given is empty.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">add</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">bytes</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) {
        <span class="macro">assert!</span>(<span class="op">!</span><span class="ident">bytes</span>.<span class="ident">is_empty</span>());
        <span class="macro">assert!</span>(<span class="self">self</span>.<span class="ident">by_id</span>.<span class="ident">len</span>() <span class="op">&lt;</span><span class="op">=</span> <span class="ident">u16::MAX</span> <span class="kw">as</span> <span class="ident">usize</span>);

        <span class="kw">let</span> <span class="ident">id</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">by_id</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">u16</span>;
        <span class="self">self</span>.<span class="ident">max_pattern_id</span> <span class="op">=</span> <span class="ident">id</span>;
        <span class="self">self</span>.<span class="ident">order</span>.<span class="ident">push</span>(<span class="ident">id</span>);
        <span class="self">self</span>.<span class="ident">by_id</span>.<span class="ident">push</span>(<span class="ident">bytes</span>.<span class="ident">to_vec</span>());
        <span class="self">self</span>.<span class="ident">minimum_len</span> <span class="op">=</span> <span class="ident">cmp::min</span>(<span class="self">self</span>.<span class="ident">minimum_len</span>, <span class="ident">bytes</span>.<span class="ident">len</span>());
        <span class="self">self</span>.<span class="ident">total_pattern_bytes</span> <span class="op">+</span><span class="op">=</span> <span class="ident">bytes</span>.<span class="ident">len</span>();
    }

    <span class="doccomment">/// Set the match kind semantics for this collection of patterns.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If the kind is not set, then the default is leftmost-first.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_match_kind</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">kind</span>: <span class="ident">MatchKind</span>) {
        <span class="kw">match</span> <span class="ident">kind</span> {
            <span class="ident">MatchKind::LeftmostFirst</span> =&gt; {
                <span class="self">self</span>.<span class="ident">order</span>.<span class="ident">sort</span>();
            }
            <span class="ident">MatchKind::LeftmostLongest</span> =&gt; {
                <span class="kw">let</span> (<span class="ident">order</span>, <span class="ident">by_id</span>) <span class="op">=</span> (<span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">order</span>, <span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">by_id</span>);
                <span class="ident">order</span>.<span class="ident">sort_by</span>(<span class="op">|</span><span class="kw-2">&amp;</span><span class="ident">id1</span>, <span class="kw-2">&amp;</span><span class="ident">id2</span><span class="op">|</span> {
                    <span class="ident">by_id</span>[<span class="ident">id1</span> <span class="kw">as</span> <span class="ident">usize</span>]
                        .<span class="ident">len</span>()
                        .<span class="ident">cmp</span>(<span class="kw-2">&amp;</span><span class="ident">by_id</span>[<span class="ident">id2</span> <span class="kw">as</span> <span class="ident">usize</span>].<span class="ident">len</span>())
                        .<span class="ident">reverse</span>()
                });
            }
            <span class="ident">MatchKind::__Nonexhaustive</span> =&gt; <span class="macro">unreachable!</span>(),
        }
    }

    <span class="doccomment">/// Return the number of patterns in this collection.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is guaranteed to be greater than zero.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">len</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="ident">by_id</span>.<span class="ident">len</span>()
    }

    <span class="doccomment">/// Returns true if and only if this collection of patterns is empty.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">is_empty</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">len</span>() <span class="op">==</span> <span class="number">0</span>
    }

    <span class="doccomment">/// Returns the approximate total amount of heap used by these patterns, in</span>
    <span class="doccomment">/// units of bytes.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">heap_bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="ident">order</span>.<span class="ident">len</span>() <span class="op">*</span> <span class="ident">mem::size_of</span>::<span class="op">&lt;</span><span class="ident">PatternID</span><span class="op">&gt;</span>()
            <span class="op">+</span> <span class="self">self</span>.<span class="ident">by_id</span>.<span class="ident">len</span>() <span class="op">*</span> <span class="ident">mem::size_of</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="op">&gt;</span>()
            <span class="op">+</span> <span class="self">self</span>.<span class="ident">total_pattern_bytes</span>
    }

    <span class="doccomment">/// Clears all heap memory associated with this collection of patterns and</span>
    <span class="doccomment">/// resets all state such that it is a valid empty collection.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">reset</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) {
        <span class="self">self</span>.<span class="ident">kind</span> <span class="op">=</span> <span class="ident">MatchKind::default</span>();
        <span class="self">self</span>.<span class="ident">by_id</span>.<span class="ident">clear</span>();
        <span class="self">self</span>.<span class="ident">order</span>.<span class="ident">clear</span>();
        <span class="self">self</span>.<span class="ident">minimum_len</span> <span class="op">=</span> <span class="ident">usize::MAX</span>;
        <span class="self">self</span>.<span class="ident">max_pattern_id</span> <span class="op">=</span> <span class="number">0</span>;
    }

    <span class="doccomment">/// Return the maximum pattern identifier in this collection. This can be</span>
    <span class="doccomment">/// useful in searchers for ensuring that the collection of patterns they</span>
    <span class="doccomment">/// are provided at search time and at build time have the same size.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">max_pattern_id</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">PatternID</span> {
        <span class="macro">assert_eq!</span>((<span class="self">self</span>.<span class="ident">max_pattern_id</span> <span class="op">+</span> <span class="number">1</span>) <span class="kw">as</span> <span class="ident">usize</span>, <span class="self">self</span>.<span class="ident">len</span>());
        <span class="self">self</span>.<span class="ident">max_pattern_id</span>
    }

    <span class="doccomment">/// Returns the length, in bytes, of the smallest pattern.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is guaranteed to be at least one.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">minimum_len</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="ident">minimum_len</span>
    }

    <span class="doccomment">/// Returns the match semantics used by these patterns.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">match_kind</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="ident">MatchKind</span> {
        <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">kind</span>
    }

    <span class="doccomment">/// Return the pattern with the given identifier. If such a pattern does</span>
    <span class="doccomment">/// not exist, then this panics.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">id</span>: <span class="ident">PatternID</span>) -&gt; <span class="ident">Pattern</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
        <span class="ident">Pattern</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">by_id</span>[<span class="ident">id</span> <span class="kw">as</span> <span class="ident">usize</span>])
    }

    <span class="doccomment">/// Return the pattern with the given identifier without performing bounds</span>
    <span class="doccomment">/// checks.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Safety</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Callers must ensure that a pattern with the given identifier exists</span>
    <span class="doccomment">/// before using this method.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">get_unchecked</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">id</span>: <span class="ident">PatternID</span>) -&gt; <span class="ident">Pattern</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
        <span class="ident">Pattern</span>(<span class="self">self</span>.<span class="ident">by_id</span>.<span class="ident">get_unchecked</span>(<span class="ident">id</span> <span class="kw">as</span> <span class="ident">usize</span>))
    }

    <span class="doccomment">/// Return an iterator over all the patterns in this collection, in the</span>
    <span class="doccomment">/// order in which they should be matched.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Specifically, in a naive multi-pattern matcher, the following is</span>
    <span class="doccomment">/// guaranteed to satisfy the match semantics of this collection of</span>
    <span class="doccomment">/// patterns:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```ignore</span>
    <span class="doccomment">/// for i in 0..haystack.len():</span>
    <span class="doccomment">///   for p in patterns.iter():</span>
    <span class="doccomment">///     if haystack[i..].starts_with(p.bytes()):</span>
    <span class="doccomment">///       return Match(p.id(), i, i + p.bytes().len())</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Namely, among the patterns in a collection, if they are matched in</span>
    <span class="doccomment">/// the order provided by this iterator, then the result is guaranteed</span>
    <span class="doccomment">/// to satisfy the correct match semantics. (Either leftmost-first or</span>
    <span class="doccomment">/// leftmost-longest.)</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">iter</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">PatternIter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
        <span class="ident">PatternIter</span> { <span class="ident">patterns</span>: <span class="self">self</span>, <span class="ident">i</span>: <span class="number">0</span> }
    }
}

<span class="doccomment">/// An iterator over the patterns in the `Patterns` collection.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The order of the patterns provided by this iterator is consistent with the</span>
<span class="doccomment">/// match semantics of the originating collection of patterns.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The lifetime `&#39;p` corresponds to the lifetime of the collection of patterns</span>
<span class="doccomment">/// this is iterating over.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">PatternIter</span><span class="op">&lt;</span><span class="lifetime">&#39;p</span><span class="op">&gt;</span> {
    <span class="ident">patterns</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;p</span> <span class="ident">Patterns</span>,
    <span class="ident">i</span>: <span class="ident">usize</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;p</span><span class="op">&gt;</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">PatternIter</span><span class="op">&lt;</span><span class="lifetime">&#39;p</span><span class="op">&gt;</span> {
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> (<span class="ident">PatternID</span>, <span class="ident">Pattern</span><span class="op">&lt;</span><span class="lifetime">&#39;p</span><span class="op">&gt;</span>);

    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">PatternID</span>, <span class="ident">Pattern</span><span class="op">&lt;</span><span class="lifetime">&#39;p</span><span class="op">&gt;</span>)<span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">i</span> <span class="op">&gt;</span><span class="op">=</span> <span class="self">self</span>.<span class="ident">patterns</span>.<span class="ident">len</span>() {
            <span class="kw">return</span> <span class="prelude-val">None</span>;
        }
        <span class="kw">let</span> <span class="ident">id</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">patterns</span>.<span class="ident">order</span>[<span class="self">self</span>.<span class="ident">i</span>];
        <span class="kw">let</span> <span class="ident">p</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">patterns</span>.<span class="ident">get</span>(<span class="ident">id</span>);
        <span class="self">self</span>.<span class="ident">i</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
        <span class="prelude-val">Some</span>((<span class="ident">id</span>, <span class="ident">p</span>))
    }
}

<span class="doccomment">/// A pattern that is used in packed searching.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Pattern</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">u8</span>]);

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">fmt::Debug</span> <span class="kw">for</span> <span class="ident">Pattern</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="ident">f</span>.<span class="ident">debug_struct</span>(<span class="string">&quot;Pattern&quot;</span>)
            .<span class="ident">field</span>(<span class="string">&quot;lit&quot;</span>, <span class="kw-2">&amp;</span><span class="ident">String::from_utf8_lossy</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="number">0</span>))
            .<span class="ident">finish</span>()
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;p</span><span class="op">&gt;</span> <span class="ident">Pattern</span><span class="op">&lt;</span><span class="lifetime">&#39;p</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Returns the length of this pattern, in bytes.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">len</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">len</span>()
    }

    <span class="doccomment">/// Returns the bytes of this pattern.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span>[<span class="ident">u8</span>] {
        <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="number">0</span>
    }

    <span class="doccomment">/// Returns the first `len` low nybbles from this pattern. If this pattern</span>
    <span class="doccomment">/// is shorter than `len`, then this panics.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">low_nybbles</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">len</span>: <span class="ident">usize</span>) -&gt; <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">nybs</span> <span class="op">=</span> <span class="macro">vec!</span>[];
        <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="ident">b</span> <span class="kw">in</span> <span class="self">self</span>.<span class="ident">bytes</span>().<span class="ident">iter</span>().<span class="ident">take</span>(<span class="ident">len</span>) {
            <span class="ident">nybs</span>.<span class="ident">push</span>(<span class="ident">b</span> <span class="op">&amp;</span> <span class="number">0xF</span>);
        }
        <span class="ident">nybs</span>
    }

    <span class="doccomment">/// Returns true if this pattern is a prefix of the given bytes.</span>
    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">is_prefix</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">bytes</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">len</span>() <span class="op">&lt;</span><span class="op">=</span> <span class="ident">bytes</span>.<span class="ident">len</span>() <span class="op">&amp;&amp;</span> <span class="self">self</span>.<span class="ident">equals</span>(<span class="kw-2">&amp;</span><span class="ident">bytes</span>[..<span class="self">self</span>.<span class="ident">len</span>()])
    }

    <span class="doccomment">/// Returns true if and only if this pattern equals the given bytes.</span>
    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">equals</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">bytes</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">bool</span> {
        <span class="comment">// Why not just use memcmp for this? Well, memcmp requires calling out</span>
        <span class="comment">// to libc, and this routine is called in fairly hot code paths. Other</span>
        <span class="comment">// than just calling out to libc, it also seems to result in worse</span>
        <span class="comment">// codegen. By rolling our own memcpy in pure Rust, it seems to appear</span>
        <span class="comment">// more friendly to the optimizer.</span>
        <span class="comment">//</span>
        <span class="comment">// This results in an improvement in just about every benchmark. Some</span>
        <span class="comment">// smaller than others, but in some cases, up to 30% faster.</span>

        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">len</span>() <span class="op">!</span><span class="op">=</span> <span class="ident">bytes</span>.<span class="ident">len</span>() {
            <span class="kw">return</span> <span class="bool-val">false</span>;
        }
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">len</span>() <span class="op">&lt;</span> <span class="number">8</span> {
            <span class="kw">for</span> (<span class="kw-2">&amp;</span><span class="ident">b1</span>, <span class="kw-2">&amp;</span><span class="ident">b2</span>) <span class="kw">in</span> <span class="self">self</span>.<span class="ident">bytes</span>().<span class="ident">iter</span>().<span class="ident">zip</span>(<span class="ident">bytes</span>) {
                <span class="kw">if</span> <span class="ident">b1</span> <span class="op">!</span><span class="op">=</span> <span class="ident">b2</span> {
                    <span class="kw">return</span> <span class="bool-val">false</span>;
                }
            }
            <span class="kw">return</span> <span class="bool-val">true</span>;
        }
        <span class="comment">// When we have 8 or more bytes to compare, then proceed in chunks of</span>
        <span class="comment">// 8 at a time using unaligned loads.</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">p1</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">bytes</span>().<span class="ident">as_ptr</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">p2</span> <span class="op">=</span> <span class="ident">bytes</span>.<span class="ident">as_ptr</span>();
        <span class="kw">let</span> <span class="ident">p1end</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">bytes</span>()[<span class="self">self</span>.<span class="ident">len</span>() <span class="op">-</span> <span class="number">8</span>..].<span class="ident">as_ptr</span>();
        <span class="kw">let</span> <span class="ident">p2end</span> <span class="op">=</span> <span class="ident">bytes</span>[<span class="ident">bytes</span>.<span class="ident">len</span>() <span class="op">-</span> <span class="number">8</span>..].<span class="ident">as_ptr</span>();
        <span class="comment">// SAFETY: Via the conditional above, we know that both `p1` and `p2`</span>
        <span class="comment">// have the same length, so `p1 &lt; p1end` implies that `p2 &lt; p2end`.</span>
        <span class="comment">// Thus, derefencing both `p1` and `p2` in the loop below is safe.</span>
        <span class="comment">//</span>
        <span class="comment">// Moreover, we set `p1end` and `p2end` to be 8 bytes before the actual</span>
        <span class="comment">// end of of `p1` and `p2`. Thus, the final dereference outside of the</span>
        <span class="comment">// loop is guaranteed to be valid.</span>
        <span class="comment">//</span>
        <span class="comment">// Finally, we needn&#39;t worry about 64-bit alignment here, since we</span>
        <span class="comment">// do unaligned loads.</span>
        <span class="kw">unsafe</span> {
            <span class="kw">while</span> <span class="ident">p1</span> <span class="op">&lt;</span> <span class="ident">p1end</span> {
                <span class="kw">let</span> <span class="ident">v1</span> <span class="op">=</span> (<span class="ident">p1</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="ident">u64</span>).<span class="ident">read_unaligned</span>();
                <span class="kw">let</span> <span class="ident">v2</span> <span class="op">=</span> (<span class="ident">p2</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="ident">u64</span>).<span class="ident">read_unaligned</span>();
                <span class="kw">if</span> <span class="ident">v1</span> <span class="op">!</span><span class="op">=</span> <span class="ident">v2</span> {
                    <span class="kw">return</span> <span class="bool-val">false</span>;
                }
                <span class="ident">p1</span> <span class="op">=</span> <span class="ident">p1</span>.<span class="ident">add</span>(<span class="number">8</span>);
                <span class="ident">p2</span> <span class="op">=</span> <span class="ident">p2</span>.<span class="ident">add</span>(<span class="number">8</span>);
            }
            <span class="kw">let</span> <span class="ident">v1</span> <span class="op">=</span> (<span class="ident">p1end</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="ident">u64</span>).<span class="ident">read_unaligned</span>();
            <span class="kw">let</span> <span class="ident">v2</span> <span class="op">=</span> (<span class="ident">p2end</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="ident">u64</span>).<span class="ident">read_unaligned</span>();
            <span class="ident">v1</span> <span class="op">==</span> <span class="ident">v2</span>
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="aho_corasick" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>